//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
/* Include files */
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <assert.h>
#include "cbw.h"
#include <stdio.h> /* location of: printf() */
#include <stdlib.h> /* location of: atof(), atoi() */
#include <string.h> /* location of: strlen() */
#include "sicl.h"
#include <Chart.hpp>
#include <Series.hpp>
void SICLCALLBACK err_handler (INST id, int error);
int DataLength;


void trig(bool a);
/* Prototypes */
int InitIO( void );
void WriteIO( char *buffer );
unsigned long ReadByte( char *buffer, unsigned long BytesToRead);
unsigned long ReadWord( short *buffer, unsigned long BytesToRead);
void ReadDouble( double *buffer );
void CloseIO( void );
void AcquireData( void );
void GetVoltageConversionFactors( double *yInc, double *yOrg );
void GetTimeConversionFactors( double *xInc, double *xOrg );
void CreateTimeData( double xInc,double xOrg,unsigned long AcquiredLength,
double *TimeValues );
void ConvertWordDataToVolts( short *byteData,double *byteVolts,
unsigned long AcquiredLength,double yInc,double yOrg );
void ConvertByteDataToVolts( char *byteData,double *byteVolts,
unsigned long AcquiredLength,double yInc,double yOrg );
void WriteCsvToFile( double *TimeValues,double *wordVolts,
unsigned long AcquiredLength);
unsigned long SetupDataTransfer( void );

int DataReduction(double *wordVolts,unsigned long AcquiredLength,
double xInc,double xOrg,double *RedwordVolts,double *RedTime);



/* Defines */
#define MAX_LENGTH 2097152

#define DEVICE_ADDR "hpib7,7"
#define TRUE 1
#define FALSE 0
#define IO_TIMEOUT 700000
/* Globals */

INST bus;
INST scope;
unsigned long N;
double TimeValues[MAX_LENGTH]; /* Time value of data */
double byteVolts[MAX_LENGTH]; /* Voltage value of data in byte format */
double wordVolts[MAX_LENGTH];/* Voltage value of data in word format */
double RedwordVolts[999];
double RedTime[999];
short wordData[MAX_LENGTH/2]; /* Buffer for reading word format data */
char byteData[MAX_LENGTH]; /* Buffer for reading byte format data */
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
int BoardNum = 0;
   int ULStat = 0;
   int PortType = AUXPORT;
   int Direction = DIGITALOUT;
   int BitNum= 0;
  // WORD BitValue;
   unsigned short BitValue=0;
bool B;

//------------------------------------------------------ ---------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{


  // ULStat = cbDConfigBit (BoardNum, PortType, BitNum,Direction);
    //  BitValue= 0;
  // cbDBitOut (BoardNum,PortType,BitNum,BitValue);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  //BitValue= 1;
  //cbDBitOut (BoardNum,PortType,BitNum,BitValue);
  //Timer2->Enabled=True;  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
 //BitValue= 0;
  //cbDBitOut (BoardNum,PortType,BitNum,BitValue);
  //Timer2->Enabled=False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
TLineSeries *Ser;

double xOrg=0.0, xInc=0.0; /* Values used to create time data */
double yOrg=0.0, yInc=0.0; /* Values used to convert data to volts */
char Term;
unsigned long BytesToRead;
//WriteIO("*RST");
WriteIO(":ACQuire:AVERAGE ON");
WriteIO(":ACQUIRE:AVERAGE:COUNT 50");
iclear(scope);
WriteIO("*CLS");
AcquireData();
WriteIO( ":WAVeform:FORMat WORD" ); /* Setup transfer format */
WriteIO( ":WAVeform:BYTeorder LSBFirst" );/* Setup transfer of LSB first */
WriteIO( ":WAVeform:SOURce CHANnel1" ); /* Waveform data source channel 1 */
GetVoltageConversionFactors( &yInc, &yOrg );
BytesToRead = SetupDataTransfer();
ReadWord( wordData, BytesToRead );
ReadByte( &Term, 1L ); /* Read termination character */
ConvertWordDataToVolts( wordData, wordVolts, BytesToRead,yInc, yOrg );
GetTimeConversionFactors( &xInc, &xOrg );
CreateTimeData( xInc, xOrg, BytesToRead, TimeValues );

WriteIO(":ACQuire:AVERAGE OFF");


DataLength=DataReduction(wordVolts,BytesToRead/2,xInc,xOrg,RedwordVolts,RedTime);

Ser = new TLineSeries(this);

Form1->Chart1->AddSeries(Ser);

for (int b=0;b<DataLength;b++)
{
Ser->AddXY(RedTime[b],RedwordVolts[b],"",clRed);
}



}
//---------------------------------------------------------------------------
void trig(bool a)
{
  //if (a)
  //Form1->Timer1->Enabled=True;
  //else
  //Form1->Timer1->Enabled=False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{

InitIO();
}
//---------------------------------------------------------------------------
/*****************************************************************************
* Function name: InitIO
* Parameters: none
* Return value: none
* Description: This routine initializes the SICL environment. It sets up
* error handling, opens both an interface and device session,
* sets timeout values, clears the GPIB interface card,
* and clears the oscilloscopes GPIB card by performing a
* Selected Device Clear.
******************************************************************************/
int InitIO( void )
{
ionerror(err_handler); /* set-up interface error handling */


scope = iopen(DEVICE_ADDR);

 /* open the scope device session */
if ( scope == 0) {
exit(1);
return False;
}
itimeout( scope, IO_TIMEOUT ); /* set device timeout */
iclear( scope ); /* perform Selected Device Clear on oscilloscope */
WriteIO(":SYSTem:HEADer OFF");
WriteIO(":TIMebase:REFerence LEFT");
WriteIO(":TIMebase:RANGe 0.5;POSition -0.01");
WriteIO(":CHANnel1:RANGe 2.5;OFFSet -1.25");
//WriteIO(":CHANnel1:RANGe 8.0;OFFSet -4");
WriteIO(":CHANNEL1:INPut DC");
WriteIO(":CHANnel1:DISPlay ON");
WriteIO(":TRIGger:EDGE:COUPling AC;SOURce EXTernal;SLOPe POSitive");
WriteIO(":TRIGger:SWEep TRIGgered");
WriteIO(":TRIGger:LEVel EXTernal,0.1");
WriteIO(":ACQuire:AVERAGE ON");
WriteIO(":ACQUIRE:AVERAGE:COUNT 10 ");
WriteIO(":ACQUIRE:SRATE 1000000");
WriteIO(":ACQuire:MODE RTIMe;POINts AUTO");

return True;
}

/*****************************************************************************
* Function name: WriteIO
* Parameters: char *buffer which is a pointer to the character
* string to be output
* Return value: none
* Description: This routine outputs strings to the oscilloscope device
* session using SICL commands.
******************************************************************************/
void WriteIO( char *buffer )
{
unsigned long actualcnt;
unsigned long BytesToWrite;
int send_end = 1;
BytesToWrite = strlen( buffer );
iwrite( scope, buffer, BytesToWrite, send_end, &actualcnt );
}
/*****************************************************************************
* Function name: ReadByte
* Parameters: char *buffer which is a pointer to the array to store
* the read bytes
* unsigned long BytesToRead which indicates the maximum
* number of bytes to read
* Return value: integer which indicates the actual number of bytes read
* Description: This routine inputs strings from the scope device session
* using SICL commands.
******************************************************************************/
unsigned long ReadByte( char *buffer, unsigned long BytesToRead )
{
unsigned long BytesRead;
int reason;
BytesRead = BytesToRead;
iread( scope, buffer, BytesToRead, &reason, &BytesRead );
return BytesRead;
}
/*****************************************************************************
* Function name: ReadWord
* Parameters: short *buffer which is a pointer to the word array
* to store the bytes read
* unsigned long BytesToRead which indicates the maximum
* number of bytes to read
* Return value: integer which indicates the actual number of bytes read
* Description: This routine inputs an array of short values from the
* oscilloscope device session using SICL commands.
******************************************************************************/
unsigned long ReadWord( short *buffer, unsigned long BytesToRead )
{
unsigned long BytesRead;
int reason;
BytesRead =BytesToRead;
iread( scope, (char *) buffer, BytesToRead, &reason, &BytesRead );
return BytesRead;
}
/*****************************************************************************
* Function name: ReadDouble
* Parameters: double *buffer which is a pointer to the float value to read
* Return value: none
* Description: This routine inputs a float value from the oscilloscope
* device session using SICL commands.
******************************************************************************/
void ReadDouble( double *buffer )
{
iscanf( scope, "%lf", buffer );
}
/*****************************************************************************
* Function name: close_IO
* Parameters: none
* Return value: none
* Description: This routine closes device and interface sessions for the
* SICL environment, and calls the routine _siclcleanup
* which de-allocates resources used by the SICL environment.
******************************************************************************/
void CloseIO( void )
{
iclose( scope ); /* close device session */
{iclose( bus );} /* close interface session */
_siclcleanup(); /* required for 16-bit applications */

}
/****************************************************************************
* Function name: AcquireData
* Parameters: none
* Return value: none
* Description: This routine acquires data using the current
* oscilloscope settings.
******************************************************************************/
void AcquireData( void )
{
/*
* The root level :DIGitize command is recommended for acquiring new
* waveform data. It initializes the oscilloscopes data buffers,
* acquires new data, and ensures that acquisition criteria are met
* before the acquisition is stopped. Note that the display is
* automatically turned off when you use this form of the :DIGitize
* command and must be turned on to view the captured data on screen.
*/
WriteIO(":DIGitize CHANnel1");
WriteIO(":CHANnel1:DISPlay ON");
//trig(false);
}
/*****************************************************************************
* Function name: GetVoltageConversionFactors
* Parameters: double yInc which is the voltage difference represented by
* adjacent waveform data digital codes.
* double yOrg which is the voltage value of digital code 0.
* Return value: none
* Description: This routine reads the conversion factors used to convert
* waveform data to volts.
******************************************************************************/
void GetVoltageConversionFactors( double *yInc, double *yOrg )
{
/* Read values which are used to convert data to voltage values */
WriteIO(":WAVeform:YINCrement?");
ReadDouble( yInc );
WriteIO(":WAVeform:YORigin?");
ReadDouble( yOrg );
}
/*****************************************************************************
* Function name: SetupDataTransfer
* Parameters: none
* Return value: Number of bytes of waveform data to read.
* Description: This routine sets up the waveform data transfer and gets
* the number of bytes to be read.
******************************************************************************/
unsigned long SetupDataTransfer( void )
{
unsigned long BytesToRead;
char header_str[9];
char cData;
unsigned long BytesRead;
int bytes_read;
WriteIO( ":WAVeform:DATA?" ); /* Request waveform data */
/* Find the # character */
do {
ReadByte( &cData, 1L );
} while ( cData != 0x23 );
/* Read the next byte which tells how many bytes to read for the number
* of waveform data bytes to transfer value.
*/
BytesRead=ReadByte(header_str,1L);

BytesToRead= atoi(header_str);
BytesRead = ReadByte( header_str, BytesToRead );

BytesToRead = atoi( header_str );
return BytesToRead;
}

/*****************************************************************************
* Function name: GetTimeConversionFactors
* Parameters: double xInc which is the time between consecutive
* sample points.
* double xOrg which is the time value of the first data point.
* Return value: none
* Description: This routine transfers the waveform conversion
* factors for the time values.
******************************************************************************/
void GetTimeConversionFactors( double *xInc, double *xOrg )
{
/* Read values which are used to create time values */
WriteIO(":WAVeform:XINCrement?");
ReadDouble( xInc );
WriteIO(":WAVeform:XORigin?");
ReadDouble( xOrg );
}
/****************************************************************************
* Function name: CreateTimeData
* Parameters: double xInc which is the time between consecutive
* sample points
* double xOrg which is the time value of the first data point
* unsigned long AcquiredLength which is the number of
* data points
* double TimeValues is a pointer to the array where time
* values are stored
* Return value: none
* Description: This routine converts the data to time values using
* the values that describe the waveform. These values are
* stored in global variables.
******************************************************************************/
void CreateTimeData( double xInc, double xOrg,
unsigned long AcquiredLength, double *TimeValues )
{
unsigned long i;
for (i = 0; i < AcquiredLength; i++) {
TimeValues[i] =(i * xInc) + xOrg; /* calculate time values */
}
}
/*****************************************************************************
* Function name: ConvertWordDataToVolts
* Parameters: short *wordData which is a pointer to the array
* of read word values
* double *wordVolts which is a pointer to the array of
* calculated voltages
* unsigned long AcquiredLength which is the number of data
* bytes read
* double yInc which is the voltage difference represented
* by adjacent waveform data digital codes.
* double yOrg which is the voltage value of digital code 0.
* Return value: none
* Description: This routine converts the word format waveform data to
* voltage values using values that describe the waveform.
* These values are stored in global arrays for use by
* other routines.
******************************************************************************/
void ConvertWordDataToVolts( short *wordData, double *wordVolts,
unsigned long AcquiredLength,
double yInc, double yOrg )
{
unsigned long i;
for (i = 0; i < AcquiredLength/2; i++) {
/* calculate voltage values */
wordVolts[i] = (wordData[i] * yInc) + yOrg;
}
}
/*****************************************************************************
* Function name: ConvertByteDataToVolts
* Parameters: short *byteData which is a pointer to the array of
* read byte values
* double *byteVolts which is a pointer to the array of
* calculated voltages
* unsigned long AcquiredLength which is the number of data
* bytes read
* double yInc which is the voltage difference represented
* by adjacent waveform data digital codes.
* double yOrg which is the voltage value of digital code 0.
* Return value: none
* Description: This routine converts the byte format waveform data to
* voltage values using the values that describe the
* waveform. These values are stored in global variables.
******************************************************************************/
void ConvertByteDataToVolts( char *byteData, double *byteVolts,
unsigned long AcquiredLength,
double yInc, double yOrg )
{
unsigned long i;
for (i = 0; i < AcquiredLength; i++) {
/* calculate voltage values */
byteVolts[i] = (byteData[i] * yInc) + yOrg;
}
}

/********************************************************/
int DataReduction(double *wordVolts,unsigned long AcquiredLength,
double xInc,double xOrg,double *RedwordVolts,double *RedTime)
{unsigned long i;
 unsigned long j=0;
 //unsigned long nleft=ceil((1e-6-xOrg)/xInc);
 //unsigned long nright=floorl((1e-5-xOrg)/xInc);
 //for (i=nleft;i<=nright;i++){
  //RedwordVolts[j]=wordVolts[i];
  //RedTime[j]=(i * xInc) + xOrg;
  //j++;
 //}
//Form1->Label1->Caption=FloatToStr(xInc)+' '+FloatToStr(xOrg);
 unsigned long nright=ceil((-xOrg)/xInc);
double sum=0;
for (i=0;i<=nright;i++){
sum=sum+wordVolts[i];
}
double Io=sum/nright;

 unsigned long beg=ceil((10e-5-xOrg)/xInc);
double Time;
unsigned long  Left;
unsigned long  Right;
unsigned long  N=floorl(log10(  ((AcquiredLength-1) * xInc + xOrg)/(beg * xInc + xOrg) )/0.02);
 int a;
double I;

for ( unsigned long k=0;k<=N;k++){
  a=floorl(((xInc*beg+xOrg)*pow(10,0.02*k)-xOrg)/xInc);
  Time=(a * xInc) + xOrg;
  Left=ceil((0.98*Time-xOrg)/xInc) ;
  Right=ceil((1.02*Time-xOrg)/xInc);
  I=0;
  for (unsigned long b=Left;b<=Right;b++)
   {
    I=I+wordVolts[b];
   }
  I=I/(Right-Left+1);
 RedwordVolts[j]=-log(I/Io);
 //RedwordVolts[j]=I-Io;
  RedTime[j]=(a * xInc) + xOrg;
  j++;
}
Form1->Label1->Caption=FloatToStr(Io);//(xInc*(a+(Right-Left+1)/2)+xOrg)
return j-1;
}

/*****************************************************************************
* Function name: WriteCsvToFile
* Parameters: double *TimeValues which is a pointer to an array of
* calculated time values
* double *wordVolts which is a pointer to an array of
* calculated word format voltage values
* double *byteVolts which is a pointer to an array of
* calculated byte format voltage values
* unsigned long AcquiredLength which is the number of data
* points read
* Return value: none
* Description: This routine stores the time and voltage information about
* the waveform as time, word format voltage, and byte format
* voltage separated by commas to a file.
******************************************************************************/
void WriteCsvToFile( double *RedTime, double *RedwordVolts,
unsigned long AcquiredLength)
{
FILE *fp;
unsigned long i;

fp = fopen(".txt", "wt" ); /* Open file in binary mode - clear file
if it already exists */
if (fp != NULL) {
//fprintf( fp, "Time,Word Volts\n");
for ( i = 0; i < AcquiredLength; i++ ) {
fprintf( fp, "%e        %e\n", RedTime[i], RedwordVolts[i] );
}
fclose( fp );
}
else {
printf("Unable to open file pairs.txt\n");
}
}



void SICLCALLBACK err_handler (INST id, int error)
{
Form1->Label1->Caption=IntToStr(error);
}
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  CloseIO( );
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button2Click(TObject *Sender)
{
//trig(true);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Save1Click(TObject *Sender)
{
FILE *fp;
unsigned long i;
if (SaveDialog1->Execute()){
char* Str1=SaveDialog1->FileName.c_str();
char* Str2=".txt";
char* Str=strcat(Str1,Str2);
fp = fopen(Str, "wt" );
if (fp != NULL) {
//fprintf( fp, "Time,Word Volts\n");
for ( i = 0; i <=DataLength-1; i++ ) {
fprintf( fp, "%e %e\n", RedTime[i], RedwordVolts[i] );
}
fclose( fp );
}
else {
printf("Unable to open file pairs.txt\n");
}
}
}
//---------------------------------------------------------------------------

